'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _dependenceManager = require('../dependence-manager');

var _dependenceManager2 = _interopRequireDefault(_dependenceManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getValue = function getValue() {
  var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var arr = path.split('.');
  var property = arr.shift();
  var value = obj[property];
  if (arr.length === 0 || !value || (typeof value === 'undefined' ? 'undefined' : (0, _typeof3.default)(value)) !== 'object') {
    return value;
  }

  return getValue(value, arr.join('.'));
}; // import db from '../database';


var fixCompany = function fixCompany(name) {
  return name === 'From WeChat' ? '' : name;
};

// const fields = [
//   '++uid',
//   'id',
//   'eventId',
//   'replayId',
//   'qrcodeId',
//   'icon',
//   'name',
//   'company',
//   'createdDate',
//   'printDate'
// ];

// db.stores({
//   attendees: fields.join(', ')
// });

var Attendee = function () {
  function Attendee() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, Attendee);

    (0, _assign2.default)(this, options);
  }

  (0, _createClass3.default)(Attendee, null, [{
    key: 'getListByEvent',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var eventUid = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;
        var Provider, records, attendees;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context.next = 3;
                return Provider.getListByEvent(eventUid);

              case 3:
                records = _context.sent;
                attendees = records.map(function (record) {
                  return new Attendee(record);
                });
                return _context.abrupt('return', attendees);

              case 6:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getListByEvent() {
        return _ref.apply(this, arguments);
      }

      return getListByEvent;
    }()

    // static async deleteByEvent(eventId) {
    //   console.info('deleteByEvent', eventId);
    //   const keysToDelete = [];
    //   await db.instance.attendees
    //     .where('eventId')
    //     .equals(eventId)
    //     .each(i => keysToDelete.push(i.uid));

    //   console.info('deleteByEvent keys', keysToDelete);

    //   return db.instance.attendees.bulkDelete(keysToDelete);
    // }

  }, {
    key: 'filter',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(eventUid, keyword) {
        var items, lowerCaseKeyword, filteredItems;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                console.info('Attendee.filter', eventUid, keyword);
                _context2.next = 3;
                return Attendee.getListByEvent(eventUid);

              case 3:
                items = _context2.sent;
                lowerCaseKeyword = keyword.trim().toLowerCase();

                if (!(lowerCaseKeyword === '')) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt('return', items);

              case 7:
                filteredItems = items.filter(function (i) {
                  return i.name.toLowerCase().indexOf(lowerCaseKeyword) > -1 || i.company.toLowerCase().indexOf(lowerCaseKeyword) > -1;
                });
                return _context2.abrupt('return', filteredItems);

              case 9:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function filter(_x5, _x6) {
        return _ref2.apply(this, arguments);
      }

      return filter;
    }()
  }, {
    key: 'searchSalesforce',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(_ref3) {
        var campaignId = _ref3.campaignId,
            keyword = _ref3.keyword;

        var limit, requests, Provider, _ref5, _ref5$compositeRespon, campaignMembers, contacts, leads, items;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                limit = 20;
                requests = [{
                  type: 'query',
                  soql: ['select Id, Name, CompanyOrAccount, MobilePhone, Phone, Email, ContactId, LeadId, ', 'Contact.Account.Industry, Lead.Industry ', 'from CampaignMember where CampaignId = \'', campaignId, '\' ', 'and (MobilePhone like \'%', keyword, '%\' ', 'or Phone like \'%', keyword, '%\' ', 'or FirstName like \'%', keyword, '%\' ', 'or LastName like \'%', keyword, '%\' ', 'or CompanyOrAccount like \'%', keyword, '%\' ', 'or Email like \'%', keyword, '%\') ', 'limit ', limit].join('')
                }, {
                  type: 'query',
                  soql: ['select Id, Name, Account.Name, Account.Industry, MobilePhone, Phone, Email ', 'from Contact where MobilePhone like \'%', keyword, '%\' ', 'or Phone like \'%', keyword, '%\' ', 'or Name like \'%', keyword, '%\' ', 'or Account.Name like \'%', keyword, '%\' ', 'or Email like \'%', keyword, '%\' ', 'limit ', limit].join('')
                }, {
                  type: 'query',
                  soql: ['select Id, Name, Company, MobilePhone, Phone, Email, Industry ', 'from Lead where MobilePhone like \'%', keyword, '%\' ', 'or Phone like \'%', keyword, '%\' ', 'or Name like \'%', keyword, '%\' ', 'or Company like \'%', keyword, '%\' ', 'or Email like \'%', keyword, '%\' ', 'limit ', limit].join('')
                }];
                Provider = _dependenceManager2.default.get('SalesforceAPIProvider');
                _context3.next = 5;
                return Provider.composite(requests);

              case 5:
                _ref5 = _context3.sent;
                _ref5$compositeRespon = (0, _slicedToArray3.default)(_ref5.compositeResponse, 3);
                campaignMembers = _ref5$compositeRespon[0].body.records;
                contacts = _ref5$compositeRespon[1].body.records;
                leads = _ref5$compositeRespon[2].body.records;
                items = [];

                campaignMembers.forEach(function (member) {
                  if (items.length >= limit) {
                    return;
                  }

                  var item = {
                    id: member.Id,
                    name: member.Name,
                    company: fixCompany(member.CompanyOrAccount),
                    mobilePhone: member.MobilePhone,
                    phone: member.Phone,
                    email: member.Email,
                    industry: 'Unknown',
                    objectType: 'Campaign Member',
                    contactId: member.ContactId,
                    leadId: member.LeadId
                  };

                  if (member.ContactId) {
                    item.industry = getValue(member, 'Contact.Account.Industry');
                  } else if (member.LeadId) {
                    item.industry = getValue(member, 'Lead.Industry');
                  }

                  items.push(item);
                });

                contacts.forEach(function (contact) {
                  if (items.length >= limit) {
                    return;
                  }

                  var index = items.findIndex(function (item) {
                    return item.contactId === contact.Id;
                  });
                  if (index > -1) {
                    return;
                  }

                  console.info('### contact', contact);
                  var item = {
                    id: contact.Id,
                    name: contact.Name,
                    company: fixCompany(getValue(contact, 'Account.Name')),
                    mobilePhone: contact.MobilePhone,
                    phone: contact.Phone,
                    email: contact.Email,
                    industry: getValue(contact, 'Account.Industry'),
                    objectType: 'Contact'
                  };

                  items.push(item);
                });

                leads.forEach(function (lead) {
                  if (items.length >= limit) {
                    return;
                  }

                  var index = items.findIndex(function (item) {
                    return item.leadId === lead.Id;
                  });
                  if (index > -1) {
                    return;
                  }

                  var item = {
                    id: lead.Id,
                    name: lead.Name,
                    company: fixCompany(lead.Company),
                    mobilePhone: lead.MobilePhone,
                    phone: lead.Phone,
                    email: lead.Email,
                    industry: lead.Industry,
                    objectType: 'Lead'
                  };

                  items.push(item);
                });

                return _context3.abrupt('return', items);

              case 15:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function searchSalesforce(_x7) {
        return _ref4.apply(this, arguments);
      }

      return searchSalesforce;
    }()

    // static async findOne(eventId, id) {
    //   const conditions = {
    //     eventId,
    //     id
    //   };

    //   const attendee = await db.instance.attendees.where(conditions).first();
    //   console.info('findOne', attendee);

    //   return attendee ? new Attendee(attendee) : attendee;
    // }

  }, {
    key: 'createOrUpdate',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(values) {
        var Provider, existedUid;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context4.next = 3;
                return Provider.exsits({
                  eventUid: values.eventUid,
                  campaignMemberId: values.campaignMemberId
                });

              case 3:
                existedUid = _context4.sent;

                if (!existedUid) {
                  _context4.next = 6;
                  break;
                }

                return _context4.abrupt('return', Attendee.update(existedUid, values));

              case 6:
                return _context4.abrupt('return', Attendee.create(values));

              case 7:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function createOrUpdate(_x8) {
        return _ref6.apply(this, arguments);
      }

      return createOrUpdate;
    }()
  }, {
    key: 'create',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(values) {
        var duplicated, Provider, uid;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                duplicated = (0, _assign2.default)({}, values);

                duplicated.createdDate = new Date();
                duplicated.updatedDate = new Date();
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context5.next = 6;
                return Provider.insert(duplicated);

              case 6:
                uid = _context5.sent;

                duplicated.uid = uid;

                return _context5.abrupt('return', new Attendee(duplicated));

              case 9:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function create(_x9) {
        return _ref7.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: 'update',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(uid, values) {
        var duplicated, Provider;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                duplicated = (0, _assign2.default)({}, values);

                duplicated.updatedDate = new Date();
                duplicated.uid = uid;
                Provider = _dependenceManager2.default.get('AttendeeDataProvider');
                _context6.next = 6;
                return Provider.update(duplicated);

              case 6:
                return _context6.abrupt('return', new Attendee(duplicated));

              case 7:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function update(_x10, _x11) {
        return _ref8.apply(this, arguments);
      }

      return update;
    }()

    // async update(values) {
    //   await db.instance.attendees.update(this.uid, values);
    //   this.replayId = values.replayId;
    //   this.qrcodeId = values.qrcodeId;
    //   this.printDate = values.printDate;
    //   this.photoURL = values.photoURL;
    //   this.name = values.name;
    //   this.company = values.company;

    //   return this;
    // }

  }]);
  return Attendee;
}();

exports.default = Attendee;