'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _moblorCore = require('moblor-core');

var _attendee = require('./attendee');

var _attendee2 = _interopRequireDefault(_attendee);

var _wechatCampaignFlow = require('./wechat-campaign-flow');

var _wechatCampaignFlow2 = _interopRequireDefault(_wechatCampaignFlow);

var _campaign = require('./campaign');

var _campaign2 = _interopRequireDefault(_campaign);

var _lead = require('./lead');

var _lead2 = _interopRequireDefault(_lead);

var _nameBadgeTemplate = require('./name-badge-template');

var _nameBadgeTemplate2 = _interopRequireDefault(_nameBadgeTemplate);

var _dependenceManager = require('../dependence-manager');

var _dependenceManager2 = _interopRequireDefault(_dependenceManager);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// const PLATFORM_EVENT_NAME = 'Charket__WeChatCampaignFlowEvent__e';

// const fields = [
//   '++uid',
//   'id',
//   'name',
//   'qrcodeId',
//   'qrcode',
//   'createdDate',
//   'template',
//   'description'
// ];

// db.stores({
//   events: fields.join(', ')
// });

// import { cometd, sf } from '../lib';
var cache = {
  nameBadgeTemplates: []
};
// import db from '../database';


var fixDateString = function fixDateString() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  if (str.endsWith('+0000')) {
    return str.substring(0, str.length - 5);
  }

  return str;
};

// let _current = null;

var hash = {};
var isDuplicate = function isDuplicate(payload) {
  var oldDate = hash[payload.CampaignMember__c];
  var newDate = new Date(fixDateString(payload.CreatedDate));
  hash[payload.CampaignMember__c] = newDate;
  if (oldDate) {
    var span = newDate - oldDate;

    return span < 2000 && span >= 0;
  }

  return false;
};

var Event = function (_MicroEvent) {
  (0, _inherits3.default)(Event, _MicroEvent);

  function Event() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;
    (0, _classCallCheck3.default)(this, Event);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Event.__proto__ || (0, _getPrototypeOf2.default)(Event)).call(this));

    if (typeof options === 'number') {
      _this.uid = options;
    }if (typeof options === 'string') {
      _this.uid = parseInt(options, 0);
    } else if ((typeof options === 'undefined' ? 'undefined' : (0, _typeof3.default)(options)) === 'object') {
      (0, _assign2.default)(_this, options);
    }

    _this._campaignMemberStatus = null;
    return _this;
  }

  (0, _createClass3.default)(Event, [{
    key: '_log',
    value: function _log(message) {
      var _console;

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      (_console = console).info.apply(_console, ['[Event] ' + message].concat(args));
    }
  }, {
    key: 'ensure',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var data;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(!this.uid || this.uid === -1)) {
                  _context.next = 2;
                  break;
                }

                throw new Error('Invalid uid ' + this.uid);

              case 2:
                _context.next = 4;
                return this.table.get(this.uid);

              case 4:
                data = _context.sent;

                data.nameBadgeTemplates = data.nameBadgeTemplates ? JSON.parse(data.nameBadgeTemplates) : [];
                (0, _assign2.default)(this, data);

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function ensure() {
        return _ref.apply(this, arguments);
      }

      return ensure;
    }()
  }, {
    key: 'synchronize',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function synchronize() {
        return _ref2.apply(this, arguments);
      }

      return synchronize;
    }()
  }, {
    key: 'getNameBadgeTemplate',
    value: function getNameBadgeTemplate(id) {
      return cache.nameBadgeTemplates.find(function (t) {
        return t.Id === id;
      });
    }
  }, {
    key: 'cacheNameBadgeTemplates',
    value: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return _nameBadgeTemplate2.default.getById(this.nameBadgeTemplates);

              case 2:
                cache.nameBadgeTemplates = _context3.sent;

              case 3:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function cacheNameBadgeTemplates() {
        return _ref3.apply(this, arguments);
      }

      return cacheNameBadgeTemplates;
    }()
  }, {
    key: 'resolveNameBadgeTemplates',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function resolveNameBadgeTemplates() {
        return _ref4.apply(this, arguments);
      }

      return resolveNameBadgeTemplates;
    }()
  }, {
    key: 'save',
    value: function save() {
      // const duplicated = JSON.parse(JSON.stringify(this));
      // duplicated.nameBadgeTemplates = JSON.stringify(duplicated.nameBadgeTemplates);
      // duplicated.createdDate = new Date(duplicated.createdDate);
      // delete duplicated.dirty;

      // return db.instance.events.put(duplicated);
    }
  }, {
    key: 'getCampaignMemberStatus',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
        var flow;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!this._campaignMemberStatus) {
                  _context5.next = 2;
                  break;
                }

                return _context5.abrupt('return', this._campaignMemberStatus);

              case 2:
                _context5.next = 4;
                return _wechatCampaignFlow2.default.getById(this.id);

              case 4:
                flow = _context5.sent;

                // cause state error
                this._campaignMemberStatus = flow.checkInStep.Rules__c.CompletionActions.CampaignMemberStatus;

                return _context5.abrupt('return', this._campaignMemberStatus);

              case 7:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getCampaignMemberStatus() {
        return _ref5.apply(this, arguments);
      }

      return getCampaignMemberStatus;
    }()
  }, {
    key: 'createOrUpdateCampaignMember',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(data) {
        var campaign, status, result;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                campaign = new _campaign2.default(this.campaignId);
                _context6.next = 3;
                return this.getCampaignMemberStatus();

              case 3:
                status = _context6.sent;
                result = {
                  id: '',
                  name: data.name
                };

                if (!(data.objectType === 'Contact')) {
                  _context6.next = 12;
                  break;
                }

                this._log('create campaign member from Contact', data.id, status);
                _context6.next = 9;
                return campaign.createCampaignMember({
                  ContactId: data.id,
                  Status: status
                });

              case 9:
                result.id = _context6.sent;
                _context6.next = 24;
                break;

              case 12:
                if (!(data.objectType === 'Lead')) {
                  _context6.next = 19;
                  break;
                }

                this._log('create campaign member from Lead', data.id, status);
                _context6.next = 16;
                return campaign.createCampaignMember({
                  LeadId: data.id,
                  Status: status
                });

              case 16:
                result.id = _context6.sent;
                _context6.next = 24;
                break;

              case 19:
                if (!(data.objectType === 'Campaign Member')) {
                  _context6.next = 24;
                  break;
                }

                this._log('update campaign member status', status);
                _context6.next = 23;
                return campaign.updateCampaignMember(data.id, {
                  Status: status
                });

              case 23:
                result.id = _context6.sent;

              case 24:
                return _context6.abrupt('return', result);

              case 25:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function createOrUpdateCampaignMember(_x3) {
        return _ref6.apply(this, arguments);
      }

      return createOrUpdateCampaignMember;
    }()
  }, {
    key: 'checkInManually',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7(data) {
        var names, campaignMemberId, result, values;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                this._log('check in manually', data);
                if (typeof data.objectType === 'undefined') {
                  names = _utils2.default.splitName(data.name);

                  (0, _assign2.default)(data, names);
                }

                if (!data.syncToSalesforce) {
                  _context7.next = 8;
                  break;
                }

                this._log('create Lead', data);
                _context7.next = 6;
                return _lead2.default.create({
                  firstName: data.firstName,
                  lastName: data.lastName,
                  company: data.company
                  // phone number / email?
                });

              case 6:
                data.id = _context7.sent;


                data.objectType = 'Lead';

              case 8:
                campaignMemberId = '';

                if (!(typeof data.objectType !== 'undefined')) {
                  _context7.next = 13;
                  break;
                }

                _context7.next = 12;
                return this.createOrUpdateCampaignMember(data);

              case 12:
                campaignMemberId = _context7.sent;

              case 13:
                result = {
                  successful: false
                };
                values = {
                  eventUid: this.uid,
                  campaignMemberId: campaignMemberId,
                  mergeFields: {
                    // todo: Industry, Note?
                    '{!CampaignMember.Name}': data.name,
                    '{!CampaignMember.CompanyOrAccount}': data.company
                  },
                  follower: {},
                  nameBadgeTemplateId: this.nameBadgeTemplates[0], // provide a choice?
                  stepId: '',
                  checkinStaffId: this.checkinStaffId,
                  qrcodeId: this.qrcodeId,
                  printDate: new Date(),
                  photoURL: '',
                  name: data.name,
                  company: data.company
                };
                _context7.next = 17;
                return _attendee2.default.createOrUpdate(values);

              case 17:
                result.attendee = _context7.sent;

                result.successful = true;
                this._log('check in is successful', result);

                return _context7.abrupt('return', result);

              case 21:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function checkInManually(_x4) {
        return _ref7.apply(this, arguments);
      }

      return checkInManually;
    }()
  }, {
    key: 'isMatchSignInTable',
    value: function isMatchSignInTable(data) {
      this._log('check in method', this.checkInMethod);
      this._log('qrcode id', this.qrcodeId);
      this._log('checkin staff id', this.checkinStaffId);

      if (this.checkInMethod === 'QRCode' && this.qrcodeId !== data.WeChatQRCode__c) {
        this._log('data.WeChatQRCode__c', data.WeChatQRCode__c);
        this._log('qrcode does not match');

        return false;
      }

      if (this.checkInMethod === 'Pass' && this.checkinStaffId !== data.WeChatCheckinStaff__c) {
        this._log('data.WeChatCheckinStaff__c', data.WeChatCheckinStaff__c);
        this._log('checkin staff does not match');

        return false;
      }

      return true;
    }
  }, {
    key: 'checkIn',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8(data) {
        var result, follower, mergeFields, values;
        return _regenerator2.default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                this._log('start check in', data);

                result = {
                  successful: false
                };

                if (!isDuplicate(data)) {
                  _context8.next = 6;
                  break;
                }

                result.reason = 'duplicated data';
                this._log('check in is failed', result);

                return _context8.abrupt('return', result);

              case 6:
                if (this.isMatchSignInTable(data)) {
                  _context8.next = 10;
                  break;
                }

                result.reason = 'sign in table does not match';
                this._log('check in is failed', result);

                return _context8.abrupt('return', result);

              case 10:
                follower = data.WeChatFollowerData__c ? JSON.parse(data.WeChatFollowerData__c) : {};
                mergeFields = data.MergeFieldsData__c ? JSON.parse(data.MergeFieldsData__c) : {};
                values = {
                  eventUid: this.uid,
                  campaignMemberId: data.CampaignMember__c,
                  mergeFields: mergeFields,
                  follower: follower,
                  nameBadgeTemplateId: data.NameBadgeTemplate__c,
                  stepId: data.WeChatCampaignFlowStep__c,
                  checkinStaffId: data.WeChatCheckinStaff__c,
                  qrcodeId: data.WeChatQRCode__c,
                  printDate: fixDateString(data.CreatedDate),
                  photoURL: follower.ProfilePhotoURL,
                  name: mergeFields['{!CampaignMember.Name}'],
                  company: mergeFields['{!CampaignMember.CompanyOrAccount}']
                };
                _context8.next = 15;
                return _attendee2.default.createOrUpdate(values);

              case 15:
                result.attendee = _context8.sent;

                result.successful = true;
                this._log('check in is successful', result);

                return _context8.abrupt('return', result);

              case 19:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function checkIn(_x5) {
        return _ref8.apply(this, arguments);
      }

      return checkIn;
    }()
  }, {
    key: 'clone',
    value: function clone() {
      return new Event(JSON.parse((0, _stringify2.default)(this)));
    }
  }, {
    key: 'table',
    get: function get() {
      // return db.instance.events;
      return '';
    }
  }], [{
    key: 'from',
    value: function from(data) {
      var event = new Event();
      (0, _assign2.default)(event, data);

      return event;
    }
  }, {
    key: 'list',
    value: function () {
      var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9() {
        var Provider, records, events;
        return _regenerator2.default.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                Provider = _dependenceManager2.default.get('EventDataProvider');
                _context9.next = 3;
                return Provider.list();

              case 3:
                records = _context9.sent;
                events = records.map(function (data) {
                  var event = Event.from(data);
                  event.nameBadgeTemplates = event.nameBadgeTemplates ? JSON.parse(event.nameBadgeTemplates) : [];

                  return event;
                });
                return _context9.abrupt('return', events);

              case 6:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function list() {
        return _ref9.apply(this, arguments);
      }

      return list;
    }()
  }, {
    key: 'create',
    value: function () {
      var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(values) {
        var duplicated, Provider, uid;
        return _regenerator2.default.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                duplicated = JSON.parse((0, _stringify2.default)(values));

                duplicated.createdDate = new Date();
                duplicated.updatedDate = new Date();
                // stringify before save
                duplicated.nameBadgeTemplates = (0, _stringify2.default)(duplicated.nameBadgeTemplates || []);
                delete duplicated.dirty;
                delete duplicated.uid;
                delete duplicated._campaignMemberStatus;
                Provider = _dependenceManager2.default.get('EventDataProvider');
                _context10.next = 10;
                return Provider.insert(duplicated);

              case 10:
                uid = _context10.sent;

                duplicated.uid = uid;
                duplicated.dirty = false;

                // parse after save
                duplicated.nameBadgeTemplates = JSON.parse(duplicated.nameBadgeTemplates || []);

                return _context10.abrupt('return', Event.from(duplicated));

              case 15:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function create(_x6) {
        return _ref10.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: 'del',
    value: function () {
      var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(uid) {
        var Provider;
        return _regenerator2.default.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                Provider = _dependenceManager2.default.get('EventDataProvider');
                // todo: delete attendees
                // await Attendee.deleteByEvent(uid);

                return _context11.abrupt('return', Provider.del(uid));

              case 2:
              case 'end':
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function del(_x7) {
        return _ref11.apply(this, arguments);
      }

      return del;
    }()
  }, {
    key: 'update',
    value: function () {
      var _ref12 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee12(values) {
        var duplicated, Provider;
        return _regenerator2.default.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                console.info('update', values);
                duplicated = JSON.parse((0, _stringify2.default)(values));

                duplicated.updatedDate = new Date();
                // stringify before save
                duplicated.nameBadgeTemplates = (0, _stringify2.default)(duplicated.nameBadgeTemplates || []);
                delete duplicated.dirty;
                delete duplicated._campaignMemberStatus;
                Provider = _dependenceManager2.default.get('EventDataProvider');
                _context12.next = 9;
                return Provider.update(duplicated);

              case 9:
                duplicated.dirty = false;

                // parse after save
                duplicated.nameBadgeTemplates = JSON.parse(duplicated.nameBadgeTemplates || []);

                return _context12.abrupt('return', Event.from(duplicated));

              case 12:
              case 'end':
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function update(_x8) {
        return _ref12.apply(this, arguments);
      }

      return update;
    }()
  }]);
  return Event;
}(_moblorCore.MicroEvent);

exports.default = Event;