'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dependenceManager = require('../dependence-manager');

var _dependenceManager2 = _interopRequireDefault(_dependenceManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NameBadgeTemplateSize = function () {
  function NameBadgeTemplateSize() {
    (0, _classCallCheck3.default)(this, NameBadgeTemplateSize);

    this.width = null;
    this.height = null;
    this.pixelWidth = null;
    this.pixelHeight = null;
  }

  (0, _createClass3.default)(NameBadgeTemplateSize, null, [{
    key: 'from',
    value: function from() {
      var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      var size = new NameBadgeTemplateSize();
      if (!str) {
        return size;
      }

      var sides = str.replace(/(mm|\s)/g, '').split('x');
      if (sides.length !== 2) {
        return size;
      }

      size.width = parseInt(sides[0], 0);
      size.height = parseInt(sides[1], 0);
      size.pixelWidth = Math.floor(size.width * 3.78);
      size.pixelHeight = Math.floor(size.height * 3.78);

      return size;
    }
  }]);
  return NameBadgeTemplateSize;
}();

var NameBadgeTemplate = function () {
  function NameBadgeTemplate(options) {
    (0, _classCallCheck3.default)(this, NameBadgeTemplate);

    (0, _assign2.default)(this, options);
    this._size = NameBadgeTemplateSize.from(this.Size__c);
    this._html = '';
  }

  (0, _createClass3.default)(NameBadgeTemplate, [{
    key: '_log',
    value: function _log(message) {
      var _console;

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      (_console = console).info.apply(_console, ['[NameBadgeTemplate] ' + message].concat(args));
    }
  }, {
    key: 'saveToLocal',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var Provider, values;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                Provider = _dependenceManager2.default.get('NameBadgeTemplateDataProvider');
                values = JSON.parse((0, _stringify2.default)(this));

                values.updatedDate = new Date();
                delete values._size;

                _context.next = 6;
                return Provider.save(values);

              case 6:
                this.uid = _context.sent;

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function saveToLocal() {
        return _ref.apply(this, arguments);
      }

      return saveToLocal;
    }()
  }, {
    key: 'merge',
    value: function merge(fields) {
      this._log('merge fields', this, fields);
      var body = this.Body__c;
      (0, _keys2.default)(fields).forEach(function (name) {
        body = body.replace(name, fields[name]);
      });

      this._html = body;
    }
  }, {
    key: 'createPrintOptions',
    value: function createPrintOptions() {
      var fields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var html = this.merge(fields);
      var width = -1;
      var height = -1;
      if (this.Orientation__c === 'Landscape') {
        width = this.size.pixelHeight - 22;
        height = this.size.pixelWidth - 7;
      } else {
        width = this.size.pixelWidth - 7;
        height = this.size.pixelHeight - 22;
      }

      var options = {
        html: html,
        width: width,
        height: height,
        orientation: this.Orientation__c.toLowerCase()
      };

      return options;
    }
  }, {
    key: 'size',
    get: function get() {
      return this._size;
    }
  }, {
    key: 'html',
    get: function get() {
      return this._html;
    }
  }], [{
    key: 'from',
    value: function from(data) {
      var instance = new NameBadgeTemplate(data);

      return instance;
    }

    // static async getFromLocal(id) {
    //   if (!id) {
    //     throw new Error('Invalid id');
    //   }

    //   const idArray = typeof id === 'string' ? [id] : id;
    //   const templates = await db.instance.nameBadgeTemplates.where('Id').anyOf(idArray).toArray();
    //   if (templates.length !== idArray.length) {
    //     return typeof id === 'string' ? null : [];
    //   }

    //   if (typeof id === 'string') {
    //     return new NameBadgeTemplate(templates[0]);
    //   }

    //   return templates.map(t => new NameBadgeTemplate(t));
    // }

  }, {
    key: 'getById',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(id) {
        var idArray, soql, Provider, result, instance, instances, promiseArray;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (id) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('Invalid id');

              case 2:
                idArray = typeof id === 'string' ? [id] : id;
                soql = ['select Id, Name, Charket__Body__c, ', 'Charket__Size__c, Charket__MergeFields__c, Charket__Orientation__c, ', 'LastModifiedDate ', 'from Charket__NameBadgeTemplate__c ', 'where Id = \'' + idArray.join('\' or Id = \'') + '\''].join('');
                Provider = _dependenceManager2.default.get('SalesforceAPIProvider');
                _context2.next = 7;
                return Provider.query(soql);

              case 7:
                result = _context2.sent;

                if (!(!result || !result.records || result.records.length === 0)) {
                  _context2.next = 10;
                  break;
                }

                return _context2.abrupt('return', typeof id === 'string' ? null : []);

              case 10:
                if (!(typeof id === 'string')) {
                  _context2.next = 15;
                  break;
                }

                instance = NameBadgeTemplate.from(result.records[0]);
                _context2.next = 14;
                return instance.saveToLocal();

              case 14:
                return _context2.abrupt('return', instance);

              case 15:
                instances = result.records.map(function (record) {
                  return NameBadgeTemplate.from(record);
                });
                promiseArray = instances.map(function (instance) {
                  return instance.saveToLocal();
                });
                _context2.next = 19;
                return _promise2.default.all(promiseArray);

              case 19:
                return _context2.abrupt('return', instances);

              case 20:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getById(_x3) {
        return _ref2.apply(this, arguments);
      }

      return getById;
    }()
  }]);
  return NameBadgeTemplate;
}();

exports.default = NameBadgeTemplate;