'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _wechatCampaignFlowStep = require('./wechat-campaign-flow-step');

var _wechatCampaignFlowStep2 = _interopRequireDefault(_wechatCampaignFlowStep);

var _dependenceManager = require('../dependence-manager');

var _dependenceManager2 = _interopRequireDefault(_dependenceManager);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var QUERY_BASE = ['select Id, Name, Charket__Campaign__c, ', '(select Id, Name, Charket__Type__c, Charket__Rules__c from Charket__WeChatCampaignFlowSteps__r) ', 'from Charket__WeChatCampaignFlow__c '].join('');

var WeChatCampaignFlowStepTypes = {
  CheckIn: 'Check-in'
};

var WeChatCampaignFlow = function () {
  function WeChatCampaignFlow(options) {
    (0, _classCallCheck3.default)(this, WeChatCampaignFlow);

    (0, _assign2.default)(this, options);
    this._checkInStep = null;
  }

  (0, _createClass3.default)(WeChatCampaignFlow, [{
    key: 'getStep',
    value: function getStep(type) {
      return this.steps.find(function (s) {
        return s.Type__c === type;
      });
    }
  }, {
    key: 'checkInStep',
    get: function get() {
      return this._checkInStep;
    }
  }], [{
    key: 'from',
    value: function from() {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      delete data.attributes;
      var steps = data.WeChatCampaignFlowSteps__r && data.WeChatCampaignFlowSteps__r.records ? data.WeChatCampaignFlowSteps__r.records : [];

      delete data.WeChatCampaignFlowSteps__r;
      data.steps = steps.map(function (step) {
        return _wechatCampaignFlowStep2.default.from(step);
      });
      var flow = new WeChatCampaignFlow(data);
      flow._checkInStep = flow.getStep(WeChatCampaignFlowStepTypes.CheckIn);

      return flow;
    }
  }, {
    key: 'getById',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(id) {
        var soql, Provider, result;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (id) {
                  _context.next = 2;
                  break;
                }

                throw new Error('Invalid id');

              case 2:
                soql = [QUERY_BASE, 'where Id = \'' + id + '\''].join('');
                Provider = _dependenceManager2.default.get('SalesforceAPIProvider');
                _context.next = 6;
                return Provider.query(soql);

              case 6:
                result = _context.sent;

                if (!(result && result.records && result.records.length > 0)) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt('return', WeChatCampaignFlow.from(result.records[0]));

              case 9:
                return _context.abrupt('return', null);

              case 10:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function getById(_x2) {
        return _ref.apply(this, arguments);
      }

      return getById;
    }()
  }, {
    key: 'search',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
        var keyword = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
        var limit = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 50;
        var soql, Provider, result, flows;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                soql = [QUERY_BASE, keyword ? 'where Name like \'%' + keyword + '%\'' : '', 'order by LastModifiedDate desc ', 'limit ' + limit].join('');
                Provider = _dependenceManager2.default.get('SalesforceAPIProvider');
                _context2.next = 4;
                return Provider.query(soql);

              case 4:
                result = _context2.sent;
                flows = result.records.map(WeChatCampaignFlow.from);
                return _context2.abrupt('return', flows);

              case 7:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function search() {
        return _ref2.apply(this, arguments);
      }

      return search;
    }()
  }]);
  return WeChatCampaignFlow;
}();

exports.default = WeChatCampaignFlow;