'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _bl = require('../bl');

var _module = require('./module');

var _module2 = _interopRequireDefault(_module);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _state = {
  current: null,
  items: [],
  filteredItems: []
};

var calculateDate = function calculateDate(attendees) {
  var arr = toString.apply(attendees) === '[object Array]' ? attendees : [attendees];
  arr.forEach(function (item, index) {
    item.LocalDateString = new Date(item.printDate).toLocaleString();
    var timePassed = (new Date() - new Date(item.printDate)) / 1000;
    if (timePassed >= 3600 * 24) {
      item.friendlyCreatedDate = item.LocalDateString;
    } else if (timePassed >= 3600 && timePassed < 7200) {
      item.friendlyCreatedDate = 'a hours ago';
    } else if (timePassed >= 7200) {
      item.friendlyCreatedDate = Math.round(timePassed / 3600) + ' hours ago';
    } else if (timePassed >= 60 && timePassed < 120) {
      item.friendlyCreatedDate = 'a minutes ago';
    } else if (timePassed >= 60) {
      item.friendlyCreatedDate = Math.round(timePassed / 60) + ' minutes ago';
    } else if (timePassed < 5) {
      item.friendlyCreatedDate = 'a few seconds ago';
    } else {
      item.friendlyCreatedDate = Math.round(timePassed) + ' seconds ago';
    }

    _vue2.default.set(arr, index, item);
  });
};

var sort = function sort(attendees) {
  attendees.sort(function (a, b) {
    var dateA = new Date(a.printDate);
    var dateB = new Date(b.printDate);
    if (dateA - dateB < 0) {
      return 1;
    }

    return -1;
  });
};

var AttendeeModule = function (_VuexModule) {
  (0, _inherits3.default)(AttendeeModule, _VuexModule);

  function AttendeeModule() {
    (0, _classCallCheck3.default)(this, AttendeeModule);
    return (0, _possibleConstructorReturn3.default)(this, (AttendeeModule.__proto__ || (0, _getPrototypeOf2.default)(AttendeeModule)).apply(this, arguments));
  }

  (0, _createClass3.default)(AttendeeModule, [{
    key: 'state',
    get: function get() {
      return _state;
    }
  }, {
    key: 'getterTypes',
    get: function get() {
      return {
        ATTENDEE_CURRENT: 'ATTENDEE_CURRENT',
        ATTENDEE_ITEMS: 'ATTENDEE_ITEMS',
        ATTENDEE_FILTERED_ITEMS: 'ATTENDEE_FILTERED_ITEMS'
      };
    }
  }, {
    key: 'actionTypes',
    get: function get() {
      return {
        ATTENDEE_FETCH: 'ATTENDEE_FETCH',
        ATTENDEE_FILTER: 'ATTENDEE_FILTER',
        ATTENDEE_SEARCH_SALESFORCE: 'ATTENDEE_SEARCH_SALESFORCE'
        // ATTENDEE_CREATE: 'ATTENDEE_CREATE',
      };
    }
  }, {
    key: 'mutationTypes',
    get: function get() {
      return {
        ATTENDEE_FILL_ITEMS: 'ATTENDEE_FILL_ITEMS',
        ATTENDEE_ADD_TO_LIST: 'ATTENDEE_ADD_TO_LIST',
        ATTENDEE_SET_FILTER_RESULT: 'ATTENDEE_SET_FILTER_RESULT',
        ATTENDEE_SET_CURRENT: 'ATTENDEE_SET_CURRENT'
      };
    }
  }, {
    key: 'getters',
    get: function get() {
      var _ref4;

      return _ref4 = {}, (0, _defineProperty3.default)(_ref4, this.types.ATTENDEE_CURRENT, function (_ref) {
        var current = _ref.current;
        return current;
      }), (0, _defineProperty3.default)(_ref4, this.types.ATTENDEE_ITEMS, function (_ref2) {
        var items = _ref2.items;
        return items;
      }), (0, _defineProperty3.default)(_ref4, this.types.ATTENDEE_FILTERED_ITEMS, function (_ref3) {
        var filteredItems = _ref3.filteredItems;
        return filteredItems;
      }), _ref4;
    }
  }, {
    key: 'actions',
    get: function get() {
      var _this2 = this,
          _ref10;

      return _ref10 = {}, (0, _defineProperty3.default)(_ref10, this.types.ATTENDEE_FETCH, function () {
        var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref5, eventUid) {
          var commit = _ref5.commit;
          var attendees;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return _bl.Attendee.getListByEvent(eventUid);

                case 2:
                  attendees = _context.sent;

                  commit(_this2.types.ATTENDEE_FILL_ITEMS, attendees);

                case 4:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this2);
        }));

        return function (_x, _x2) {
          return _ref6.apply(this, arguments);
        };
      }()), (0, _defineProperty3.default)(_ref10, this.types.ATTENDEE_FILTER, function () {
        var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(_ref7, _ref8) {
          var commit = _ref7.commit;
          var eventUid = _ref8.eventUid,
              keyword = _ref8.keyword;
          var attendees;
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return _bl.Attendee.filter(eventUid, keyword.trim());

                case 2:
                  attendees = _context2.sent;

                  commit(_this2.types.ATTENDEE_SET_FILTER_RESULT, attendees);

                  return _context2.abrupt('return', attendees);

                case 5:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, _this2);
        }));

        return function (_x3, _x4) {
          return _ref9.apply(this, arguments);
        };
      }()), (0, _defineProperty3.default)(_ref10, this.types.ATTENDEE_SEARCH_SALESFORCE, function (context, options) {
        var items = _bl.Attendee.searchSalesforce(options);

        return items;
      }), _ref10;
    }
  }, {
    key: 'mutations',
    get: function get() {
      var _ref11;

      return _ref11 = {}, (0, _defineProperty3.default)(_ref11, this.types.ATTENDEE_FILL_ITEMS, function (state, attendees) {
        sort(attendees);
        calculateDate(attendees);
        state.items = attendees;
      }), (0, _defineProperty3.default)(_ref11, this.types.ATTENDEE_ADD_TO_LIST, function (state, attendee) {
        calculateDate(attendee);
        var index = state.items.findIndex(function (i) {
          return i.uid === attendee.uid;
        });
        if (index !== -1) {
          state.items.splice(index, 1);
        }

        state.items.unshift(attendee);
      }), (0, _defineProperty3.default)(_ref11, this.types.ATTENDEE_SET_FILTER_RESULT, function (state, attendees) {
        sort(attendees);
        calculateDate(attendees);
        state.filteredItems = attendees;
      }), (0, _defineProperty3.default)(_ref11, this.types.ATTENDEE_SET_CURRENT, function (state, attendee) {
        state.current = attendee;
      }), _ref11;
    }
  }]);
  return AttendeeModule;
}(_module2.default);

exports.default = AttendeeModule;