'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var compoundSurnames = ['欧阳', '太史', '端木', '上官', '司马', '东方', '独孤', '南宫', '万俟', '闻人', '夏侯', '诸葛', '尉迟', '公羊', '赫连', '澹台', '皇甫', '宗政', '濮阳', '公冶', '太叔', '申屠', '公孙', '慕容', '仲孙', '钟离', '长孙', '宇文', '城池', '司徒', '鲜于', '司空', '汝嫣', '闾丘', '子车', '亓官', '司寇', '巫马', '公西', '颛孙', '壤驷', '公良', '漆雕', '乐正', '宰父', '谷梁', '拓跋', '夹谷', '轩辕', '令狐', '段干', '百里', '呼延', '东郭', '南门', '羊舌', '微生', '公户', '公玉', '公仪', '梁丘', '公仲', '公上', '公门', '公山', '公坚', '左丘', '公伯', '西门', '公祖', '第五', '公乘', '贯丘', '公皙', '南荣', '东里', '东宫', '仲长', '子书', '子桑', '即墨', '达奚', '褚师'];

var isChineseName = function isChineseName() {
  var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var regExp = /[\u4e00-\u9fa5]/;

  return regExp.test(name);
};

var splitName = function splitName() {
  var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var result = {
    firstName: '',
    lastName: ''
  };

  if (!isChineseName(name)) {
    var names = name.split(' ');
    result.firstName = names[0] || '';
    result.lastName = names[1] || '';
    result.name = name;

    return result;
  }

  if (name.length > 2) {
    var firstTwoCharacters = name.substring(0, 2);
    if (compoundSurnames.includes(firstTwoCharacters)) {
      result.lastName = firstTwoCharacters;
      result.firstName = name.substring(2);
    } else {
      result.lastName = name.substring(0, 1);
      result.firstName = name.substring(1);
    }
  } else if (name.length === 2) {
    result.lastName = name.substring(0, 1);
    result.firstName = name.substring(1);
  } else {
    result.lastName = name;
  }

  result.name = (result.lastName + ' ' + result.firstName).trim();

  return result;
};

var utils = {
  isChineseName: isChineseName,
  splitName: splitName
};

exports.default = utils;